## olive-editor 20221024+ds

=== CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2022 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.13 FATAL_ERROR)

project(olive-editor VERSION 0.2.0 LANGUAGES CXX)

option(BUILD_DOXYGEN "Build Doxygen documentation" OFF)
option(BUILD_TESTS "Build unit tests" OFF)
option(USE_WERROR "Error on compile warning" OFF)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

# Sanitizers
add_library(olive-sanitizers INTERFACE)
include(cmake/Sanitizers.cmake)
enable_sanitizers(olive-sanitizers)
list(APPEND OLIVE_LIBRARIES olive-sanitizers)

# Set compiler options
if(MSVC)
  set(OLIVE_COMPILE_OPTIONS
    /wd4267
    /wd4244
    /experimental:external
    /external:anglebrackets
    /external:W0
    "$<$<CONFIG:RELEASE>:/O2>"
    "$<$<COMPILE_LANGUAGE:CXX>:/MP>"
  )
  if (USE_WERROR)
    list(APPEND OLIVE_COMPILE_OPTIONS "/WX")
  endif()
else()
  set(OLIVE_COMPILE_OPTIONS
    "$<$<CONFIG:RELEASE>:-O2>"
    -Wuninitialized
    -pedantic-errors
    -Wall
    -Wextra
    -Wno-unused-parameter
    -Wshadow
  )
  if (USE_WERROR)
    list(APPEND OLIVE_COMPILE_OPTIONS "-Werror")
  endif()
endif()

set(OLIVE_DEFINITIONS -DQT_DEPRECATED_WARNINGS)
if (WIN32)
  list(APPEND OLIVE_DEFINITIONS -DUNICODE -D_UNICODE)
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

# Link OpenGL
if(UNIX AND NOT APPLE AND NOT DEFINED OpenGL_GL_PREFERENCE)
  set(OpenGL_GL_PREFERENCE LEGACY)
endif()
find_package(OpenGL REQUIRED)
list(APPEND OLIVE_LIBRARIES OpenGL::GL)

# Link OpenColorIO
find_package(OpenColorIO 2.1.1 REQUIRED)
list(APPEND OLIVE_LIBRARIES ${OCIO_LIBRARIES})
list(APPEND OLIVE_INCLUDE_DIRS ${OCIO_INCLUDE_DIRS})

# Link OpenImageIO
find_package(OpenImageIO 2.1.12 REQUIRED)
list(APPEND OLIVE_LIBRARIES ${OIIO_LIBRARIES})
list(APPEND OLIVE_INCLUDE_DIRS ${OIIO_INCLUDE_DIRS})

# Link OpenEXR
find_package(OpenEXR REQUIRED)
list(APPEND OLIVE_LIBRARIES ${OPENEXR_LIBRARIES})
list(APPEND OLIVE_INCLUDE_DIRS ${OPENEXR_INCLUDES})

# Link Qt 5
set(QT_LIBRARIES
  Core
  Gui
  Widgets
  OpenGL
  LinguistTools
  Concurrent
)
if (UNIX AND NOT APPLE)
  list(APPEND QT_LIBRARIES DBus)
endif()
find_package(Qt5 5.6 REQUIRED
  COMPONENTS
    ${QT_LIBRARIES}
  OPTIONAL_COMPONENTS
    Network
)
if (NOT Qt5Network_FOUND)
  message("   Qt5::Network module not found, crash reporting will be disabled.")
endif()
list(APPEND OLIVE_LIBRARIES
  Qt5::Core
  Qt5::Gui
  Qt5::Widgets
  Qt5::OpenGL
  Qt5::Concurrent
)

# Link FFmpeg
find_package(FFMPEG 3.0 REQUIRED
  COMPONENTS
  avutil
  avcodec
  avformat
  avfilter
  swscale
  swresample
)
list(APPEND OLIVE_INCLUDE_DIRS ${FFMPEG_INCLUDE_DIRS})
list(APPEND OLIVE_LIBRARIES
  FFMPEG::avutil
  FFMPEG::avcodec
  FFMPEG::avformat
  FFMPEG::avfilter
  FFMPEG::swscale
  FFMPEG::swresample
)

# Link PortAudio
find_package(PortAudio REQUIRED)
set(CMAKE_REQUIRED_INCLUDES ${PORTAUDIO_INCLUDE_DIRS})
include(CheckIncludeFileCXX)
check_include_file_cxx( "pa_jack.h" PA_HAS_JACK)
if (PA_HAS_JACK)
  list(APPEND OLIVE_DEFINITIONS PA_HAS_JACK)
endif()

list(APPEND OLIVE_INCLUDE_DIRS ${PORTAUDIO_INCLUDE_DIRS})
list(APPEND OLIVE_LIBRARIES ${PORTAUDIO_LIBRARIES})

# Optional: Link OpenTimelineIO
find_package(OpenTimelineIO)
if (OpenTimelineIO_FOUND)
  list(APPEND OLIVE_DEFINITIONS USE_OTIO)
  list(APPEND OLIVE_INCLUDE_DIRS ${OTIO_INCLUDE_DIRS})
  list(APPEND OLIVE_LIBRARIES ${OTIO_LIBRARIES})
else()
  message("   OpenTimelineIO interchange will be disabled.")
endif()

# Optional: Link Google Crashpad
find_package(GoogleCrashpad)
if (GoogleCrashpad_FOUND)
  list(APPEND OLIVE_DEFINITIONS USE_CRASHPAD)
  list(APPEND OLIVE_INCLUDE_DIRS ${CRASHPAD_INCLUDE_DIRS})
  list(APPEND OLIVE_LIBRARIES ${CRASHPAD_LIBRARIES})
else()
  message("   Automatic crash reporting will be disabled.")

  if (APPLE)
    # Enables use of special functions for slider dragging, only linked if Crashpad isn't found
    # because Crashpad links it itself and will cause duplicate references if we also link it
    list(APPEND OLIVE_LIBRARIES "-framework ApplicationServices")
  endif()
endif()

if (WIN32)
  list(APPEND OLIVE_DEFINITIONS "-DUNICODE -D_UNICODE")
elseif (APPLE)
  list(APPEND OLIVE_LIBRARIES "-framework IOKit")
elseif(UNIX)
  list(APPEND OLIVE_LIBRARIES Qt5::DBus)
endif()

# Generate Git hash
set(PROJECT_LONG_VERSION ${PROJECT_VERSION})
if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
  find_package(Git)
  if(GIT_FOUND)
    execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse --short=8 HEAD
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      OUTPUT_VARIABLE GIT_HASH
      OUTPUT_STRIP_TRAILING_WHITESPACE
    )

    set(PROJECT_LONG_VERSION ${PROJECT_VERSION}-${GIT_HASH})
  endif()
endif()

# Optional: Find Doxygen if requested
if(BUILD_DOXYGEN)
  find_package(Doxygen)
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)
list(APPEND OLIVE_INCLUDE_DIRS ${CMAKE_SOURCE_DIR}/ext)

add_subdirectory(app)

if (BUILD_TESTS)
enable_testing()
add_subdirectory(tests)
endif()

=== app/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2022 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Set Olive sources and resources
set(OLIVE_SOURCES
  core.h
  core.cpp
)

#set(OLIVE_RESOURCES)

# Add subdirectories, which will populate the above variables
add_subdirectory(audio)
add_subdirectory(cli)
add_subdirectory(codec)
add_subdirectory(common)
add_subdirectory(config)
add_subdirectory(dialog)
add_subdirectory(node)
add_subdirectory(packaging)
add_subdirectory(panel)
add_subdirectory(render)
add_subdirectory(shaders)
add_subdirectory(task)
add_subdirectory(timeline)
add_subdirectory(ts)
add_subdirectory(tool)
add_subdirectory(ui)
add_subdirectory(undo)
add_subdirectory(widget)
add_subdirectory(window)

# Add translations
qt5_add_translation(OLIVE_QM_FILES ${OLIVE_TS_FILES})

set(QRC_BODY "")
foreach(QM_FILE ${OLIVE_QM_FILES})
  get_filename_component(QM_FILENAME_COMPONENT ${QM_FILE} NAME_WE)
  string(APPEND QRC_BODY "<file alias=\"${QM_FILENAME_COMPONENT}\">${QM_FILE}</file>\n")
endforeach()
configure_file(ts/translations.qrc.in ts/translations.qrc @ONLY)

set(OLIVE_RESOURCES
  ${OLIVE_RESOURCES}
  ${CMAKE_CURRENT_BINARY_DIR}/ts/translations.qrc
)

# Add version object
add_library(olive-version-obj
  OBJECT
  version.cpp
  version.h
)
target_link_libraries(olive-version-obj PRIVATE Qt5::Core)
target_compile_options(olive-version-obj PRIVATE -DAPPVERSION="${PROJECT_VERSION}" -DAPPVERSIONLONG="${PROJECT_LONG_VERSION}" )

# Add main library
add_library(libolive-editor
  OBJECT
  ${OLIVE_SOURCES}
  ${OLIVE_RESOURCES}
)

# Remove prefix - prevents CMake calling it "liblibolive-editor"
set_target_properties(libolive-editor PROPERTIES PREFIX "")

# Add application
add_executable(olive-editor
  main.cpp
  $<TARGET_OBJECTS:libolive-editor>
  $<TARGET_OBJECTS:olive-version-obj>
)

# Create docs if doxygen was found
if(DOXYGEN_FOUND)
  set(DOXYGEN_PROJECT_NAME "Olive")
  set(DOXYGEN_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/docs")
  set(DOXYGEN_EXTRACT_ALL "YES")
  set(DOXYGEN_EXTRACT_PRIVATE "YES")
  doxygen_add_docs(docs ALL ${OLIVE_SOURCES})
endif()

# Platform-specific deployment preferences
if (WIN32)
  # Set Windows application icon
  target_sources(olive-editor PRIVATE packaging/windows/resources.rc)

  # Preserve folder structure in visual studio
  source_group(TREE ${CMAKE_CURRENT_SOURCE_DIR} FILES ${OLIVE_SOURCES})

elseif(APPLE)
  # Set Mac application icon
  set(OLIVE_ICON packaging/macos/olive.icns)
  target_sources(olive-editor PRIVATE ${OLIVE_ICON})

  # Set Mac bundle properties
  set_target_properties(olive-editor PROPERTIES
    MACOSX_BUNDLE TRUE
    MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/packaging/macos/MacOSXBundleInfo.plist.in
    MACOSX_BUNDLE_GUI_IDENTIFIER org.olivevideoeditor.Olive
    MACOSX_BUNDLE_ICON_FILE olive.icns
    MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
    MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION}
    MACOSX_BUNDLE_BUNDLE_NAME "Olive"
    MACOSX_BUNDLE_INFO_STRING "Olive ${PROJECT_LONG_VERSION}"
    MACOSX_BUNDLE_COPYRIGHT "©2018-2021 Olive Studios LLC and others. Published under the GNU General Public License version 3.0."
    RESOURCE "${OLIVE_ICON}"
    OUTPUT_NAME "Olive"
  )
elseif(UNIX)
  # Set Linux-specific properties for application
  install(TARGETS olive-editor RUNTIME DESTINATION bin)
endif()

# Set link libraries
target_link_libraries(olive-editor PRIVATE ${OLIVE_LIBRARIES})
target_link_libraries(libolive-editor PRIVATE ${OLIVE_LIBRARIES})

# Set compile options
target_compile_options(olive-editor PRIVATE ${OLIVE_COMPILE_OPTIONS})
target_compile_options(libolive-editor PRIVATE ${OLIVE_COMPILE_OPTIONS})

# Set global definitions
target_compile_definitions(olive-editor PRIVATE ${OLIVE_DEFINITIONS})
target_compile_definitions(libolive-editor PRIVATE ${OLIVE_DEFINITIONS})

# Set include dirs
target_include_directories(olive-editor PRIVATE ${OLIVE_INCLUDE_DIRS})
target_include_directories(libolive-editor PRIVATE ${OLIVE_INCLUDE_DIRS})

# Add crash handler
if (GoogleCrashpad_FOUND AND Qt5Network_FOUND)
  add_subdirectory(crashhandler)
endif()

=== app/codec/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2022 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(ffmpeg)
add_subdirectory(oiio)

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  codec/conformmanager.cpp
  codec/conformmanager.h
  codec/decoder.cpp
  codec/decoder.h
  codec/encoder.cpp
  codec/encoder.h
  codec/exportcodec.cpp
  codec/exportcodec.h
  codec/exportformat.cpp
  codec/exportformat.h
  codec/frame.cpp
  codec/frame.h
  codec/planarfiledevice.cpp
  codec/planarfiledevice.h
  codec/samplebuffer.cpp
  codec/samplebuffer.h
  PARENT_SCOPE
)

=== app/common/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2022 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  common/bezier.cpp
  common/bezier.h
  common/cancelableobject.h
  common/channellayout.h
  common/clamp.h
  common/commandlineparser.cpp
  common/commandlineparser.h
  common/crashpadinterface.cpp
  common/crashpadinterface.h
  common/crashpadutils.h
  common/debug.cpp
  common/debug.h
  common/decibel.h
  common/define.h
  common/ffmpegutils.cpp
  common/ffmpegutils.h
  common/filefunctions.cpp
  common/filefunctions.h
  common/html.cpp
  common/html.h
  common/jobtime.cpp
  common/jobtime.h
  common/lerp.h
  common/memorypool.h
  common/ocioutils.cpp
  common/ocioutils.h
  common/oiioutils.cpp
  common/oiioutils.h
  common/otioutils.h
  common/qtutils.cpp
  common/qtutils.h
  common/range.h
  common/ratiodialog.cpp
  common/ratiodialog.h
  common/rational.cpp
  common/rational.h
  common/threadsafemap.h
  common/timecodefunctions.cpp
  common/timecodefunctions.h
  common/timerange.cpp
  common/timerange.h
  common/tohex.h
  common/util.h
  common/xmlutils.cpp
  common/xmlutils.h
  PARENT_SCOPE
)

=== app/crashhandler/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2022 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Create crash handler executable
add_executable(
  olive-crashhandler
  crashhandler.cpp
  crashhandler.h
  $<TARGET_OBJECTS:olive-version-obj>
)

# Disable console appearing on crash handler dialog
set_target_properties(olive-crashhandler PROPERTIES
  WIN32_EXECUTABLE TRUE
)

# Set crash handler includes
target_include_directories(
  olive-crashhandler
  PRIVATE
  ${CMAKE_SOURCE_DIR}/app
  ${CRASHPAD_INCLUDE_DIRS}
)

# Set crash handler libs
target_link_libraries(
  olive-crashhandler
  PRIVATE
  Qt5::Core
  Qt5::Gui
  Qt5::Widgets
  Qt5::Network
  ${CRASHPAD_LIBRARIES}
)

set(CRASHPAD_HANDLER "crashpad_handler${CMAKE_EXECUTABLE_SUFFIX}")
set(MINIDUMP_STACKWALK "minidump_stackwalk${CMAKE_EXECUTABLE_SUFFIX}")

if(APPLE)
  # Move crash handler executables inside Mac app bundle
  add_custom_command(TARGET olive-crashhandler POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy_if_different olive-crashhandler $<TARGET_FILE_DIR:olive-editor>
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CRASHPAD_LIBRARY_DIRS}/${CRASHPAD_HANDLER} $<TARGET_FILE_DIR:olive-editor>
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${BREAKPAD_BIN_DIR}/${MINIDUMP_STACKWALK} $<TARGET_FILE_DIR:olive-editor>
  )
elseif(UNIX)
  install(TARGETS olive-crashhandler RUNTIME DESTINATION bin)
  install(PROGRAMS ${CRASHPAD_LIBRARY_DIRS}/${CRASHPAD_HANDLER} DESTINATION bin)
  install(PROGRAMS ${BREAKPAD_BIN_DIR}/${MINIDUMP_STACKWALK} DESTINATION bin)
endif()

target_compile_definitions(olive-crashhandler PRIVATE ${OLIVE_DEFINITIONS})

=== app/node/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2022 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(audio)
add_subdirectory(block)
add_subdirectory(color)
add_subdirectory(distort)
add_subdirectory(effect)
add_subdirectory(filter)
add_subdirectory(generator)
add_subdirectory(gizmo)
add_subdirectory(group)
add_subdirectory(input)
add_subdirectory(keying)
add_subdirectory(math)
add_subdirectory(output)
add_subdirectory(project)
add_subdirectory(time)

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  node/factory.cpp
  node/factory.h
  node/globals.cpp
  node/globals.h
  node/graph.cpp
  node/graph.h
  node/inputdragger.cpp
  node/inputdragger.h
  node/inputimmediate.cpp
  node/inputimmediate.h
  node/keyframe.cpp
  node/keyframe.h
  node/node.cpp
  node/node.h
  node/param.cpp
  node/param.h
  node/splitvalue.h
  node/traverser.cpp
  node/traverser.h
  node/value.cpp
  node/value.h
  node/valuedatabase.cpp
  node/valuedatabase.h
  PARENT_SCOPE
)

=== app/packaging/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2022 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

if(UNIX AND NOT APPLE)
  add_subdirectory(linux)
endif()

=== app/panel/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2022 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(audiomonitor)
add_subdirectory(curve)
add_subdirectory(footageviewer)
add_subdirectory(multicam)
add_subdirectory(node)
add_subdirectory(param)
add_subdirectory(pixelsampler)
add_subdirectory(project)
add_subdirectory(scope)
add_subdirectory(sequenceviewer)
add_subdirectory(table)
add_subdirectory(taskmanager)
add_subdirectory(timebased)
add_subdirectory(timeline)
add_subdirectory(tool)
add_subdirectory(viewer)

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  panel/panelmanager.h
  panel/panelmanager.cpp
  PARENT_SCOPE
)

=== app/render/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2022 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(job)
add_subdirectory(ocioconf)
add_subdirectory(opengl)

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  render/audioparams.cpp
  render/audioparams.h
  render/audioplaybackcache.cpp
  render/audioplaybackcache.h
  render/audiowaveformcache.cpp
  render/audiowaveformcache.h
  render/cancelatom.h
  render/color.cpp
  render/color.h
  render/colorprocessor.cpp
  render/colorprocessor.h
  render/colorprocessorcache.h
  render/diskmanager.cpp
  render/diskmanager.h
  render/framehashcache.cpp
  render/framehashcache.h
  render/framemanager.cpp
  render/framemanager.h
  render/managedcolor.cpp
  render/managedcolor.h
  render/playbackcache.cpp
  render/playbackcache.h
  render/previewaudiodevice.cpp
  render/previewaudiodevice.h
  render/previewautocacher.cpp
  render/previewautocacher.h
  render/renderer.cpp
  render/renderer.h
  render/rendercache.h
  render/renderjobtracker.cpp
  render/renderjobtracker.h
  render/rendermanager.cpp
  render/rendermanager.h
  render/rendermodes.h
  render/renderprocessor.cpp
  render/renderprocessor.h
  render/renderticket.cpp
  render/renderticket.h
  render/shadercode.h
  render/subtitleparams.cpp
  render/subtitleparams.h
  render/texture.cpp
  render/texture.h
  render/videoparams.cpp
  render/videoparams.h
  PARENT_SCOPE
)

set(OLIVE_RESOURCES
  ${OLIVE_RESOURCES}
  PARENT_SCOPE
)

=== app/shaders/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2022 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

file(GLOB_RECURSE SHADER_RESOURCES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.frag *.vert)
set(QRC_BODY "")
foreach(SHADER_FILE ${SHADER_RESOURCES})
  string(APPEND QRC_BODY "<file>${SHADER_FILE}</file>\n")
  configure_file(${SHADER_FILE} ${SHADER_FILE} COPYONLY)
endforeach()
configure_file(shaders.qrc.in shaders.qrc @ONLY)

set(OLIVE_RESOURCES
  ${OLIVE_RESOURCES}
  ${CMAKE_CURRENT_BINARY_DIR}/shaders.qrc
  PARENT_SCOPE
)

=== app/task/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2022 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(conform)
add_subdirectory(customcache)
add_subdirectory(export)
add_subdirectory(precache)
add_subdirectory(project)
add_subdirectory(render)

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  task/task.h
  task/taskmanager.h
  task/taskmanager.cpp
  PARENT_SCOPE
)

=== app/timeline/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2022 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  timeline/timelinecommon.h
  timeline/timelinecoordinate.h
  timeline/timelinecoordinate.cpp
  timeline/timelinemarker.h
  timeline/timelinemarker.cpp
  timeline/timelineworkarea.h
  timeline/timelineworkarea.cpp
  PARENT_SCOPE
)

=== debian/changelog ===
olive-editor (20221024+ds-1) unstable; urgency=medium

  * New upstream version. (Closes: #1022066)

 -- Gürkan Myczko <tar@debian.org>  Mon, 24 Oct 2022 08:04:06 +0200

=== debian/control ===
Source: olive-editor
Section: video
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Gürkan Myczko <tar@debian.org>
Build-Depends: debhelper-compat (= 13),
 qtmultimedia5-dev,
 libqt5multimedia5-plugins,
 libavfilter-dev,
 libqt5opengl5-dev,
 frei0r-plugins-dev,
 libqt5opengl5-dev,
 libqt5svg5-dev,
 libavformat-dev,
 libavcodec-dev,
 libavutil-dev,
 libswscale-dev,
 libswresample-dev,
 libpostproc-dev,
 portaudio19-dev,
 cmake,
 qttools5-dev,
 libopencolorio-dev,
 libopenimageio-dev,
 libopenexr-dev
Standards-Version: 4.6.1
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/multimedia-team/olive-editor.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/olive-editor
Homepage: https://www.olivevideoeditor.org/

Package: olive-editor
Architecture: amd64 arm64 mips64el ppc64el s390x alpha ppc64 riscv64
Depends: ${shlibs:Depends}, ${misc:Depends}, ffmpeg, frei0r-plugins, libqt5multimedia5-plugins
Description: Professional open-source NLE video editor
 This is a free non-linear video editor. It provides sensible cutting tools,
 and basic FX animation. There are solic color and title generators, for cutting
 it has tools like Razor, Ripple, Slide, and Slip.

## olive-editor 20230614+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Olive - Non-Linear Video Editor
-# Copyright (C) 2022 Olive Team
+# Copyright (C) 2023 Olive Studios LLC
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,6 +18,7 @@
 
 project(olive-editor VERSION 0.2.0 LANGUAGES CXX)
 
+option(BUILD_QT6 "Build with Qt 6 over 5 (experimental)" OFF)
 option(BUILD_DOXYGEN "Build Doxygen documentation" OFF)
 option(BUILD_TESTS "Build unit tests" OFF)
 option(USE_WERROR "Error on compile warning" OFF)
@@ -29,6 +30,10 @@
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTOUIC ON)
 set(CMAKE_AUTORCC ON)
+
+# Generates a compile_commands.json in the build dir, link that to the repo
+# root to enrich your IDE with clangd language server protocol functionalities
+set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 
 # Sanitizers
 add_library(olive-sanitizers INTERFACE)
@@ -94,7 +99,11 @@
 list(APPEND OLIVE_LIBRARIES ${OPENEXR_LIBRARIES})
 list(APPEND OLIVE_INCLUDE_DIRS ${OPENEXR_INCLUDES})
 
-# Link Qt 5
+# Link Olive
+list(APPEND OLIVE_LIBRARIES olivecore)
+list(APPEND OLIVE_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/ext/core/include)
+
+# Link Qt
 set(QT_LIBRARIES
   Core
   Gui
@@ -106,21 +115,56 @@
 if (UNIX AND NOT APPLE)
   list(APPEND QT_LIBRARIES DBus)
 endif()
-find_package(Qt5 5.6 REQUIRED
+if (BUILD_QT6)
+  set(QT_NAME Qt6)
+else()
+  set(QT_NAME Qt5)
+endif()
+find_package(QT
+  NAMES
+    ${QT_NAME}
+  REQUIRED
   COMPONENTS
     ${QT_LIBRARIES}
   OPTIONAL_COMPONENTS
     Network
 )
-if (NOT Qt5Network_FOUND)
-  message("   Qt5::Network module not found, crash reporting will be disabled.")
+find_package(Qt${QT_VERSION_MAJOR} REQUIRED
+  COMPONENTS
+    ${QT_LIBRARIES}
+  OPTIONAL_COMPONENTS
+    Network
+)
+if (NOT Qt${QT_VERSION_MAJOR}Network_FOUND)
+  message("   Qt${QT_VERSION_MAJOR}::Network module not found, crash reporting will be disabled.")
 endif()
 list(APPEND OLIVE_LIBRARIES
-  Qt5::Core
-  Qt5::Gui
-  Qt5::Widgets
-  Qt5::OpenGL
-  Qt5::Concurrent
+  Qt${QT_VERSION_MAJOR}::Core
+  Qt${QT_VERSION_MAJOR}::Gui
+  Qt${QT_VERSION_MAJOR}::Widgets
+  Qt${QT_VERSION_MAJOR}::OpenGL
+  Qt${QT_VERSION_MAJOR}::Concurrent
+)
+
+if (${QT_VERSION_MAJOR} EQUAL "6")
+  find_package(Qt${QT_VERSION_MAJOR}
+    REQUIRED
+      OpenGLWidgets
+  )
+
+  list(APPEND OLIVE_LIBRARIES
+    Qt${QT_VERSION_MAJOR}::OpenGLWidgets
+  )
+
+  # Link KDDockWidgets
+  #find_package(KDDockWidgets-qt6 CONFIG REQUIRED)
+else()
+  # Link KDDockWidgets
+  #find_package(KDDockWidgets CONFIG REQUIRED)
+endif()
+
+list(APPEND OLIVE_LIBRARIES
+  KDAB::kddockwidgets
 )
 
 # Link FFmpeg
@@ -186,7 +230,7 @@
 elseif (APPLE)
   list(APPEND OLIVE_LIBRARIES "-framework IOKit")
 elseif(UNIX)
-  list(APPEND OLIVE_LIBRARIES Qt5::DBus)
+  list(APPEND OLIVE_LIBRARIES Qt${QT_VERSION_MAJOR}::DBus)
 endif()
 
 # Generate Git hash
@@ -212,9 +256,10 @@
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 list(APPEND OLIVE_INCLUDE_DIRS ${CMAKE_SOURCE_DIR}/ext)
 
+add_subdirectory(ext)
 add_subdirectory(app)
 
 if (BUILD_TESTS)
-enable_testing()
-add_subdirectory(tests)
-endif()
+  enable_testing()
+  add_subdirectory(tests)
+endif()

=== app/CMakeLists.txt ===
--- 
+++ 
@@ -44,7 +44,7 @@
 add_subdirectory(window)
 
 # Add translations
-qt5_add_translation(OLIVE_QM_FILES ${OLIVE_TS_FILES})
+qt_add_translation(OLIVE_QM_FILES ${OLIVE_TS_FILES})
 
 set(QRC_BODY "")
 foreach(QM_FILE ${OLIVE_QM_FILES})
@@ -64,7 +64,7 @@
   version.cpp
   version.h
 )
-target_link_libraries(olive-version-obj PRIVATE Qt5::Core)
+target_link_libraries(olive-version-obj PRIVATE Qt${QT_VERSION_MAJOR}::Core)
 target_compile_options(olive-version-obj PRIVATE -DAPPVERSION="${PROJECT_VERSION}" -DAPPVERSIONLONG="${PROJECT_LONG_VERSION}" )
 
 # Add main library
@@ -142,6 +142,6 @@
 target_include_directories(libolive-editor PRIVATE ${OLIVE_INCLUDE_DIRS})
 
 # Add crash handler
-if (GoogleCrashpad_FOUND AND Qt5Network_FOUND)
+if (GoogleCrashpad_FOUND AND Qt${QT_VERSION_MAJOR}Network_FOUND)
   add_subdirectory(crashhandler)
 endif()

=== ext/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2023 Olive Studios LLC
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(core EXCLUDE_FROM_ALL)

set(KDDockWidgets_STATIC ON CACHE INTERNAL "Force KDDockWidgets to build statically")
set(KDDockWidgets_QT6 ${BUILD_QT6} CACHE INTERNAL "Conform KDDockWidgets' Qt 6 setting to ours")
add_subdirectory(KDDockWidgets EXCLUDE_FROM_ALL)

=== tests/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2022 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

function(olive_add_test GROUP NAME SOURCE)
  file(READ "${SOURCE}" TEST_FILE_CONTENT)
  string(REGEX MATCHALL "OLIVE_ADD_TEST\(.[A-Za-z0-9_]+\)" TEST_FUNCTIONS ${TEST_FILE_CONTENT})
  set(TEST_BODY "int main(int argc, char** argv)\n{\n  int ret;(void)ret;")
  set(TEST_INDEX 1)
  list(LENGTH TEST_FUNCTIONS TEST_COUNT)
  foreach (TEST_FUNC ${TEST_FUNCTIONS})
    string(REPLACE "OLIVE_ADD_TEST(" "" TEST_FUNC "${TEST_FUNC}")
    string(APPEND TEST_BODY "  std::cout << \"[${TEST_INDEX}/${TEST_COUNT}] ${GROUP} - ${TEST_FUNC}\";\n")
    string(APPEND TEST_BODY "  if ((ret = olive::Test${TEST_FUNC}()) == OLIVE_TEST_SUCCESS) {std::cout << \" - PASSED\" << std::endl;}else{std::cout << \" - FAILED AT LINE \" << ret << std::endl;return 1;}\n")
    MATH(EXPR TEST_INDEX "${TEST_INDEX}+1")
  endforeach()
  string(APPEND TEST_BODY "  return 0;\n}")

  set_property(
    DIRECTORY
    APPEND
    PROPERTY CMAKE_CONFIGURE_DEPENDS ${SOURCE}
  )

  set(OUTPUT_FILE "${CMAKE_CURRENT_BINARY_DIR}/${SOURCE}")

  string(APPEND TEST_FILE_CONTENT "\n${TEST_BODY}")
  file(WRITE "${OUTPUT_FILE}" "${TEST_FILE_CONTENT}")

  add_executable(${NAME} ${OUTPUT_FILE} $<TARGET_OBJECTS:libolive-editor>)
  target_include_directories(
    ${NAME}
    PRIVATE
    ${CMAKE_SOURCE_DIR}/app
    ${CMAKE_SOURCE_DIR}/tests
    ${OLIVE_INCLUDE_DIRS}
  )
  target_link_libraries(
    ${NAME}
    PRIVATE
    ${OLIVE_LIBRARIES}
  )
  target_compile_definitions(
    ${NAME}
    PRIVATE
    ${OLIVE_DEFINITIONS}
  )
  target_compile_options(
    ${NAME}
    PRIVATE
    ${OLIVE_COMPILE_OPTIONS}
  )
  if (MSVC)
    add_test("Olive.${GROUP}.${NAME}" ${NAME})
  else()
    add_test(${NAME} ${NAME})
endif()
endfunction()

add_subdirectory(compositing)
add_subdirectory(general)
add_subdirectory(timeline)

=== app/audio/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2022 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  audio/audiomanager.cpp
  audio/audiomanager.h
  audio/audioprocessor.cpp
  audio/audioprocessor.h
  audio/audiovisualwaveform.cpp
  audio/audiovisualwaveform.h
  PARENT_SCOPE
)

=== app/cli/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2022 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(cliprogress)
add_subdirectory(clitask)

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  PARENT_SCOPE
)

=== app/codec/CMakeLists.txt ===
--- 
+++ 
@@ -33,7 +33,5 @@
   codec/frame.h
   codec/planarfiledevice.cpp
   codec/planarfiledevice.h
-  codec/samplebuffer.cpp
-  codec/samplebuffer.h
   PARENT_SCOPE
 )

=== app/common/CMakeLists.txt ===
--- 
+++ 
@@ -16,11 +16,8 @@
 
 set(OLIVE_SOURCES
   ${OLIVE_SOURCES}
-  common/bezier.cpp
-  common/bezier.h
   common/cancelableobject.h
   common/channellayout.h
-  common/clamp.h
   common/commandlineparser.cpp
   common/commandlineparser.h
   common/crashpadinterface.cpp
@@ -50,13 +47,7 @@
   common/range.h
   common/ratiodialog.cpp
   common/ratiodialog.h
-  common/rational.cpp
-  common/rational.h
   common/threadsafemap.h
-  common/timecodefunctions.cpp
-  common/timecodefunctions.h
-  common/timerange.cpp
-  common/timerange.h
   common/tohex.h
   common/util.h
   common/xmlutils.cpp

=== app/config/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2022 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  config/config.h
  config/config.cpp
  PARENT_SCOPE
)

=== app/crashhandler/CMakeLists.txt ===
--- 
+++ 
@@ -39,10 +39,10 @@
 target_link_libraries(
   olive-crashhandler
   PRIVATE
-  Qt5::Core
-  Qt5::Gui
-  Qt5::Widgets
-  Qt5::Network
+  Qt${QT_VERSION_MAJOR}::Core
+  Qt${QT_VERSION_MAJOR}::Gui
+  Qt${QT_VERSION_MAJOR}::Widgets
+  Qt${QT_VERSION_MAJOR}::Network
   ${CRASHPAD_LIBRARIES}
 )

=== app/dialog/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2022 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(about)
add_subdirectory(actionsearch)
add_subdirectory(autorecovery)
add_subdirectory(color)
add_subdirectory(configbase)
add_subdirectory(diskcache)
add_subdirectory(export)
add_subdirectory(footageproperties)
add_subdirectory(footagerelink)
add_subdirectory(keyframeproperties)
add_subdirectory(markerproperties)
if(OpenTimelineIO_FOUND)
  add_subdirectory(otioproperties)
endif()
add_subdirectory(preferences)
add_subdirectory(progress)
add_subdirectory(projectproperties)
add_subdirectory(rendercancel)
add_subdirectory(sequence)
add_subdirectory(speedduration)
add_subdirectory(task)
add_subdirectory(text)

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  PARENT_SCOPE
)

=== app/node/CMakeLists.txt ===
--- 
+++ 
@@ -36,8 +36,6 @@
   node/factory.h
   node/globals.cpp
   node/globals.h
-  node/graph.cpp
-  node/graph.h
   node/inputdragger.cpp
   node/inputdragger.h
   node/inputimmediate.cpp
@@ -46,8 +44,12 @@
   node/keyframe.h
   node/node.cpp
   node/node.h
+  node/nodeundo.cpp
+  node/nodeundo.h
   node/param.cpp
   node/param.h
+  node/project.cpp
+  node/project.h
   node/splitvalue.h
   node/traverser.cpp
   node/traverser.h

=== debian/changelog ===
olive-editor (20230614+ds-2) unstable; urgency=medium

  * d/control: add missing build-depends qtbase5-private-dev,
    qttools5-private-dev, qtbase5-dev, libqwt-qt5-dev, libqt5x11extras5-dev.
    (Closes: #1060206)
  * Bump standards version to 4.7.0.
  * New upstream version. (Closes: #1068137)

 -- Alex Myczko <tar@debian.org>  Thu, 04 Jan 2024 09:19:21 +0100

olive-editor (20230614+ds-1) unstable; urgency=medium

  * New upstream version.
  * Apply patch to also build on loong64, thanks yalingfang.
    (Closes: #1059958)
  * d/copyright: bump year.

 -- Gürkan Myczko <tar@debian.org>  Thu, 04 Jan 2024 08:16:50 +0100

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,15 @@
 Section: video
 Priority: optional
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
-Uploaders: Gürkan Myczko <tar@debian.org>
+Uploaders: Alex Myczko <tar@debian.org>
 Build-Depends: debhelper-compat (= 13),
  qtmultimedia5-dev,
+ qt6-multimedia-dev,
+ qml6-module-qtmultimedia,
  libqt5multimedia5-plugins,
  libavfilter-dev,
  libqt5opengl5-dev,
+ libqt5x11extras5-dev,
  frei0r-plugins-dev,
  libqt5opengl5-dev,
  libqt5svg5-dev,
@@ -20,17 +23,21 @@
  portaudio19-dev,
  cmake,
  qttools5-dev,
+ qtbase5-dev,
+ qtbase5-private-dev,
+ qttools5-private-dev,
+ libqwt-qt5-dev,
  libopencolorio-dev,
  libopenimageio-dev,
  libopenexr-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/multimedia-team/olive-editor.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/olive-editor
 Homepage: https://www.olivevideoeditor.org/
 
 Package: olive-editor
-Architecture: amd64 arm64 mips64el ppc64el s390x alpha ppc64 riscv64
+Architecture: amd64 arm64 mips64el ppc64el s390x alpha ppc64 riscv64 loong64
 Depends: ${shlibs:Depends}, ${misc:Depends}, ffmpeg, frei0r-plugins, libqt5multimedia5-plugins
 Description: Professional open-source NLE video editor
  This is a free non-linear video editor. It provides sensible cutting tools,

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export QTDIR=/usr/share/qt5
export QT_SELECT=qt5

%:
	dh $@

#override_dh_auto_configure:
#	dh_auto_configure -- \
#	    -DQt5X11Extras_DIR=/usr/lib/x86_64-linux-gnu/cmake/Qt5X11Extras/
#	qmake -makefile PREFIX=$(shell pwd)/olive/usr olive.pro
#	sed -i "s,-DQT_NO_DEBUG,,g" Makefile
#	sed -i 's/^CXXFLAGS.*/& -g/g' Makefile
